## Version 2.2.0, 2016.10.30

* Add `backgroundAlpha` and `foregroundAlpha` options to control transparency [#63](https://github.com/neocotic/qrious/issues/63)

## Version 2.1.0, 2016.10.04

* Allow `padding` to be set explicitly [#44](https://github.com/neocotic/qrious/issues/44)
* Fix support for older browsers [#55](https://github.com/neocotic/qrious/issues/55)
* Update code style to fit with other projects
* Update build system to run on older Node.js versions at a reduced capacity

## Version 2.0.2, 2016.08.05

* Fix bug where mask is incorrectly applied [#50](https://github.com/neocotic/qrious/issues/50)

## Version 2.0.1, 2016.07.03

* Correct license mentioned into `README.md`

## Version 2.0.0, 2016.06.26

* Rename library to QRious and move package from `qr-js` to `qrious`
* Completely redesign API to follow OOP pattern for simplicity
* Remove `save` and `saveSync` method
* Remove `noConflict` method
* Remove documentation generated by `docco`
* Restructure code base to make it more maintainable and use [Rollup](http://rollupjs.org) to build it
* Provide better built-in support for [Browserify](http://browserify.org) and [Webpack](http://webpack.github.io) etc
* Switch from [JSHint](https://github.com/jshint/jshint) to [ESLint](http://eslint.org)
* Add `demo.html` to allow contributors to experiment and test with changes due to lack of unit tests
* Remove `INSTALL.md` and consolidate contents into `README.md` and `CONTRIBUTING.md`
* Add [EditorConfig](http://editorconfig.org) file
* Add support for [Travis CI](https://travis-ci.org)

## Version 1.1.4, 2015.11.11

* Fix padding issues [#2](https://github.com/neocotic/qrious/issues/2)
* Make the QR code center-aligned [#35](https://github.com/neocotic/qrious/pull/35)
* Update [node-canvas](https://github.com/Automattic/node-canvas) dependency version to support [Node.js](https://nodejs.org) v4 and above [#38](https://github.com/neocotic/qrious/pull/38)

## Version 1.1.3, 2014.09.01

* Revert back to [GPL License](http://www.gnu.org/licenses/) [#23](https://github.com/neocotic/qrious/issues/23)

## Version 1.1.2, 2014.04.27

* Fix "too many open files" bug [#20](https://github.com/neocotic/qrious/issues/20)

## Version 1.1.1, 2013.12.03

* Fix bug with IIFE

## Version 1.1.0, 2013.12.02

* Fix [RequireJS](http://requirejs.org) support [#9](https://github.com/neocotic/qrious/issues/9)
* Remove [Ender](http://enderjs.com) support [#13](https://github.com/neocotic/qrious/issues/13)
* Improve code formatting and style [#14](https://github.com/neocotic/qrious/issues/14)
* Support different MIME types for `toDataURL` and other related functions [#16](https://github.com/neocotic/qrious/issues/16)
* Remove unnecessary callback arguments from synchronous functions [#17](https://github.com/neocotic/qrious/issues/17)
* Make `save` fully asynchronous [#17](https://github.com/neocotic/qrious/issues/17)
* Add `saveSync` for synchronous saving [#17](https://github.com/neocotic/qrious/issues/17)
* Add [Grunt](http://gruntjs.com) build system [#18](https://github.com/neocotic/qrious/issues/18)
* Generate source map as part of build [#18](https://github.com/neocotic/qrious/issues/18)
* Improve developer documentation [#18](https://github.com/neocotic/qrious/issues/18)
* Add support for [Bower](https://bower.io) [#19](https://github.com/neocotic/qrious/issues/19)
* Many small fixes and tweaks

## Version 1.0.3, 2011.12.19

* Rename `QRCode` to `qr` [#3](https://github.com/neocotic/qrious/issues/3)
* Remove all deprecated methods [#3](https://github.com/neocotic/qrious/issues/3)
* Reformat code and add additional, along with some original, code comments [#4](https://github.com/neocotic/qrious/issues/4)
* Add support for [Node.js](https://nodejs.org), [CommonJS](http://www.commonjs.org) and [Ender](http://enderjs.com) [#6](https://github.com/neocotic/qrious/issues/6)
* Add optional `callback` functionality to API methods [#6](https://github.com/neocotic/qrious/issues/6)
* Allow `data` arguments to be an object or string value [#7](https://github.com/neocotic/qrious/issues/7)
* Add `VERSION` property to the API [#8](https://github.com/neocotic/qrious/issues/8)
* Add `toDataURL`, `save` and `noConflict` methods to the API [#8](https://github.com/neocotic/qrious/issues/8)
* Now distributed under the MIT license

## Version 1.0.2, 2011.08.31

* Deprecate `generateCanvas` and `generateImage` and replaced with `canvas` and `image` respectively [#1](https://github.com/neocotic/qrious/issues/1)

## Version 1.0.1, 2011.08.12

* Allow customisation of colours used when rendering
